/**
 * ファイルアップロード　ユーティリティ
 */

/**
 * コンストラクタ
 * 引数
 * ・targetSpanId       :ファイル名を表示するspan領域のIDを指定する
 * ・hiddenFileName     :ファイル名を格納するhiddenのnameを指定する
 * ・hiddenFilePathName :ファイルパスを格納するhiddenのnameを指定する
 * ・isDelete           :削除アイコンを表示するかboolで指定する
 */
function FileUploadUtil(instanceName, targetSpanId, hiddenFileName, hiddenFilePathName, imgagePath, isDelete){
  this._instanceName        = instanceName;
  this._targetSpanId        = targetSpanId;
  this._hiddenFileName      = hiddenFileName;
  this._hiddenFilePathName  = hiddenFilePathName;
  this.isDelete             = isDelete;
  this._filePathArray       = new Array();
  this._fileNameArray       = new Array();
  this._uploadFileConutName = "uploadFileConut";
  
  this._imgagePath 					= imgagePath;					//3カ国語対応
  
  this._uploadFncNm					= "addUploadFile";		//jspでのファイル添付の関数名
  this._addButtonArea				= "addButtonArea";		//jspでの追加ボタン表示域
  this._isMulty							= "1";								//jspでの複数ファイル添付の可否：1=可,0=不可
  this._masterXmlTag				= "buildImagePath";		//添付ファイル保存先が格納されたmasterXMLタグ
  this._isRadio             = false;							//jspでのRadio表示非表示：true=表示,false=非表示
  this._radioObjectName     = "";						      //Radioのobject名	(isRadioがtrueの場合、必要項目)
  this._filePath            = "";　　　　　　　　　//添付ファイルのpathの前path(isRadioがtrueの場合、必要項目)　
  
  this.addFile = function(fileName, filePath){
    this._fileNameArray.push(fileName);
    this._filePathArray.push(filePath);
  }
  
  this.setUploadFileConutName = function(uploadFileConutName){
    this._uploadFileConutName = uploadFileConutName;
  }
  
  this.setMasterXmlTag = function(masterXmlTag){
    this._masterXmlTag = masterXmlTag;
  }
  
  this.setUploadFncNm = function(uploadFncNm){
    this._uploadFncNm = uploadFncNm;
  } 
  
  this.setAddButtonArea = function(addButtonArea){
    this._addButtonArea = addButtonArea;
  }  
  
   this.setIsMulty = function(isMulty){
    this._isMulty = isMulty;
  }  
  
  this.setIsRadio = function(isRadio, radioObjectName, filePath){
    this._isRadio = isRadio;
    this._radioObjectName = radioObjectName;
    this._filePath = filePath;
  }  
  
  
  
  /**
   * ファイルアップロード画面を開き、ファイルアップロードを行う
   * 説明：以下の処理を行う
   * 1      ファイルアップロードダイアログの表示を行う
   * 2.1    アップロードされた場合
   * 2.1.1  サーバサイドの物理ファイル名を本クラスに保持する
   *        アップロード済みの一覧のファイル名を配列で返す
   * 2.2    キャンセルされた場合
   * 2.2.1  アップロード済みの一覧のファイル名を配列で返す
   * 戻り値：アップロードファイルのファイル名のArrayを返す
   */
  this.opanWindow = function(ulPath,imageOnly){
    val = showModalDialog(ROOT_DIR + "/ComControl?processId=twigs&action=upload&uploadPath=" + ulPath + "&imageOnly=" + imageOnly , window, C_FILE_UPLOAD_DIALOG_OPTIONS);

    if (typeof(val) == "undefined"){
      return this._fileNameArray;
    }
    if(val[0] == "") {
      return this._fileNameArray;
    }

    this.addFile(val[0], val[1]);
    return this._fileNameArray;
  }
  
  /**
   * 指定添え字のファイルをダウンロードする（ビル外観向け）
   */
  this.buildImageDownload = function(pos){
    this.fileDownload("buildImagePath", pos);
  }
  
  /**
   * 指定添え字のファイルをダウンロードする（ビル地図向け）
   */
  this.buildMapDownload = function(pos){
    this.fileDownload("buildMapPath", pos);
  }


  /**
   * 指定添え字のファイルをダウンロードする
   */
  this.fileDownload = function(pos){
    //this.fileDownload = function(pos){
    var saveTarget    = document.forms[0].target;
    var saveProcessId = document.forms[0].processId.value;
    var saveActionId  = document.forms[0].action.value;
    
    //document.forms[0].target                  = "fraTemp";
    //document.forms[0].processId.value         = "common";
    //document.forms[0].action.value            = "fileDownLoad";
    //document.forms[0].PassTag.value           = this._masterXmlTag;
    //document.forms[0].FilePass.value          = "";
    //document.forms[0].FileName.value          = this._fileNameArray[pos];
    //document.forms[0].InternalFileName.value  = this._filePathArray[pos];
    //document.forms[0].submit();


    url = ROOT_DIR + "/ComControl?processId=common";
    url +="&action=fileDownLoad"; 
    url +="&pageAction=get";
  	url +="&PassTag="+this._masterXmlTag;
		url +="&FilePass=";
		url +="&FileName="+this._fileNameArray[pos];
		url +="&InternalFileName="+this._filePathArray[pos];
    document.fraFile.location.href = url;
    
    document.forms[0].target          = saveTarget;
    document.forms[0].processId.value = saveProcessId;
    document.forms[0].action.value    = saveActionId;
  }

  /**
   * 指定の添え字のファイル情報を削除する
   */
  this.deleteFile = function(pos){
    var pathArray1 = this._filePathArray.slice(0, pos);
    var pathArray2 = this._filePathArray.slice(pos+1);
    this._filePathArray = pathArray1.concat(pathArray2);
    
    var nameArray1 = this._fileNameArray.slice(0, pos);
    var nameArray2 = this._fileNameArray.slice(pos+1);
    this._fileNameArray = nameArray1.concat(nameArray2);
    
    var spanArea = eval(this._targetSpanId);
    spanArea.innerHTML = this.getLinkHtml();
  }
  
  /**
   * 現在保持しているアップロードファイルの情報をアンカー付きのHTMLで返す
   * 戻り値：アップロードファイルのHTMLを返す
   * 複数ファイル添付が可の時、or添付ファイルがない時、追加ボタンを表示する。
   *		表示場所：this._addButtonArea　,onClickイベント：this._uploadFncNm
   * hiddenのnameは以下の通り
   * アップロードされたファイル名：引数の「this._hiddenFileName」で指定した文字列に数値を付加したもの
   * サーバ側の一次ファイル名：引数の「this._hiddenFilePathName」で指定した文字列に数値を付加したもの
   * アップロード済みのファイル数：「uploadFileConut」
   */
  this.getLinkHtml = function(){
  
  	if(this._addButtonArea == ""){
  		return this.getHtml(true,  this._instanceName + ".deleteFile");
  	}
  	var buttonArea = eval(this._addButtonArea);
  	buttonArea.innerHTML = "";
  	if(this._isMulty=="1"){
  		buttonArea.innerHTML = "<img src=\"" + this._imgagePath + "/icon/file_temp.gif\" alt =\"Add\" class=\"hand\" align=\"absmiddle\" onClick=\"" + this._uploadFncNm + "(); return false;\">";
  	}else{
  		if(this._fileNameArray.length == 0){
  			buttonArea.innerHTML = "<img src=\"" + this._imgagePath + "/icon/file_temp.gif\" alt =\"Add\" class=\"hand\" align=\"absmiddle\" onClick=\"" + this._uploadFncNm + "(); return false;\">";
  		}
  	}
    return this.getHtml(true,  this._instanceName + ".deleteFile");
  }
  
  
   /**
   * 現在保持しているアップロードファイルの情報をアンカー付きのHTMLで返す
   * 戻り値：アップロードファイルのHTMLを返す
   * hiddenのnameは以下の通り
   * アップロードされたファイル名：引数の「this._hiddenFileName」で指定した文字列に数値を付加したもの
   * サーバ側の一次ファイル名：引数の「this._hiddenFilePathName」で指定した文字列に数値を付加したもの
   * アップロード済みのファイル数：「uploadFileConut」
   */
  this.getDtlLinkHtml = function(){
    return this.getHtml(true,  this._instanceName + ".deleteFile");
  }
  


  /**
   * 現在保持しているアップロードファイルの情報をアンカーなしのHTMLで返す
   * 戻り値：アップロードファイルのHTMLを返す
   *        hiddenのnameは以下の通り
   *        アップロードされたファイル名：引数の「this._hiddenFileName」で指定した文字列に数値を付加したもの
   *        サーバ側の一次ファイル名：引数の「this._hiddenFilePathName」で指定した文字列に数値を付加したもの
   *        アップロード済みのファイル数：「uploadFileConut」
   */
  this.getNoLinkHtml = function(){
    return this.getHtml(false,  this._instanceName + ".deleteFile");
  }
  
  /**
   * 現在保持しているアップロードファイルの情報をHTMLで返す（table版）
   * ファイルダウンロードのアンカーはboolで指定する
   * 戻り値：アップロードファイルのHTMLを返す
   *        hiddenのnameは以下の通り
   *        アップロードされたファイル名：引数の「this._hiddenFileName」で指定した文字列に数値を付加したもの
   *        サーバ側の一次ファイル名：引数の「this._hiddenFilePathName」で指定した文字列に数値を付加したもの
   *        アップロード済みのファイル数：「uploadFileConut」
   */
  this.getHtml = function(isLink, deleteFunctionName){
    var downloadFuncNm = "fileDownload";
    var style = "cursor:hand;color=blue;text-decoration:underline;";
    
    var html = '';
    html = '<table style="padding:0px;margin:0px;border:0px;">'
    for(ii = 0; ii < this._fileNameArray.length; ii++){
      shortFileName = this.getShortFileName(this._fileNameArray[ii]);
      html += '<tr>'
      html += '<td style="padding:0px;" width="100%">';

    	if(this._isRadio){
        html += '<input type="radio" name="' + this._radioObjectName + '" value="' + this._filePath + this._filePathArray[ii].replace(/\\/g, "\\\\") +'" class="bgBlue">';
      }  
      
      if(isLink){
        html += '<span style="' + style + '" onclick="' + this._instanceName + '.' + downloadFuncNm + '(' + ii + '); return false;">' + shortFileName + '</span>';
      }else{
        html += shortFileName;
      }
      
      html += '</td>';
      html += '<td style="padding:0px;" width="0%" onclick="' + deleteFunctionName + '(' + ii + ');">';
      
      if(isDelete){
        html += '<img src="' + this._imgagePath + '/icon/file_erase.gif" alt="Del" width="45" height="16" border="0" align="right" class=\"hand\" style="cursor:hand;">';
      }
      
      html += '<input type="hidden" name="' + this._hiddenFileName + ii + '" value="' + this._fileNameArray[ii] +'">';
      html += '<input type="hidden" name="' + this._hiddenFilePathName + ii + '" value="' + this._filePathArray[ii].replace(/\\/g, "\\\\") +'">';
      html += '</td>';
      html += '</tr>'
    }
    html += '</table>'
    html += '<input type="hidden" name="' + this._uploadFileConutName + '" value="' + this._fileNameArray.length +'">';

    return html;
  }
  

  /**
   * 現在保持しているアップロードファイルの情報をHTMLで返す（プレーン版）
   * ファイルダウンロードのアンカーはboolで指定する
   * 戻り値：アップロードファイルのHTMLを返す
   *        hiddenのnameは以下の通り
   *        アップロードされたファイル名：引数の「this._hiddenFileName」で指定した文字列に数値を付加したもの
   *        サーバ側の一次ファイル名：引数の「this._hiddenFilePathName」で指定した文字列に数値を付加したもの
   *        アップロード済みのファイル数：「uploadFileConut」
   */
  this.getPlainHtml = function(){
    var html = "";
    for(ii = 0; ii < this._fileNameArray.length; ii++){
      if(ii != 0){
        html += ", "
      }
      shortFileName = this.getShortFileName(this._fileNameArray[ii]);
      html += shortFileName;
    }
    return html;
  }

  /**
   * 指定のファイル名を定数値で切った文字列を返す
   */
  this.getShortFileName = function(fileName){
    var postFix = "";
    if(fileName.length > C_UPLOAD_FILE_VIEW_LENGTH){
      postFix = "..";
    }
    return fileName.substr(0, C_UPLOAD_FILE_VIEW_LENGTH) + postFix;
  }
}
